create table T_provider (
	provider_id SERIAL,
	provider_name text,
	provider_dhcp inet,  
	provider_auth_url text,
	provider_net  inet,
	provider_netmask inet,
	primary key (provider_id));

create table T_macbind (
	mac_addr macaddr,
	provider_id bigint,
	mac_reg_date timestamp,
	primary key (mac_addr));

create view V_mapping as select M.mac_addr, P.provider_dhcp, P.provider_net, P.provider_netmask, P.provider_auth_url from T_macbind as M,T_provider as P where M.provider_id = P.provider_id;

grant all on T_provider to macbind;
grant all on T_macbind to macbind;
grant all on V_mapping to macbind;

INSERT INTO T_provider (provider_name, provider_dhcp, provider_auth_url,
                        provider_net, provider_netmask)
	   VALUES ('default', '192.168.0.2', 'http://10.0.0.1', '10.0.0.0', '255.255.255.0');
