<?php

// Looks up in /proc/net/arp the MAC address of a given $ip address
// This is Linux specific
function getmac($ip)
{
	$fp = fopen("/proc/net/arp", "r");
	while(!feof($fp)) {
		$line = fgets($fp, 128);
		if($line == "")
			break;
		$field = preg_split('/\s{2,}/', $line);
		if($field[0] == $ip) {
			fclose($fp);
			return $field[3];
		}
	}
	fclose($fp);
	return FALSE;
}

function print_header($title)
{
	print "<html><head><title>$title</title></head><body BGCOLOR=white>\n";
	print "<p style='text-align: center;'>".
		"<i>(</i><a href='index.php'>login</a><i>)</i> &nbsp;".
		"<i>(</i><a href='stats.php'>stats</a><i>)</i> &nbsp;".
		"<i>(</i><a href='list.php'>userlist</a><i>)</i> &nbsp;".
		"</p><hr>\n";
	print "<table width='100%'><tr>\n";
	print "<td><img src='sthlmopen.png' alt='logo'></td><td valign=top>\n";
}

function print_footer()
{
	print "</td></tr></table></td></body></html>\n";
}

function print_error($errmsg)
{
	print_header("Error");
	print $errmsg . "\n";
	print_footer();
}

function open_socket()
{
	$fp = fsockopen("/tmp/oasis", 0, $errno, $errstr);

	if(!$fp) {
		print_error("<p>Unable to connect to oasis:".
					" <b>$errstr</b> ($errno)</p>");
		exit();
	}

	return $fp;
}

function get_reply($fp)
{
	$reply = fgets($fp, 128);
	return explode(" ", $reply, 2);
}

function login($fp, $user, $domain, $pass, $ip, $mac)
{
	fputs($fp, "LOGIN\rUSER=$user\rDOMAIN=$domain\rPASS=$pass\r".
		  "IP=$ip\rMAC=$mac\r\n");
	return get_reply($fp);
}

function stats($fp, $user, $domain)
{
	fputs($fp, "STATS\r\n");
	return get_reply($fp);
}

function list_users($fp, $user, $domain)
{
	fputs($fp, "LIST\r\n");
	return get_reply($fp);
}

?>
